//! # D-Bus interface proxy for: `io.github.wivrn.Server`
//!
//! This code was generated by `zbus-xmlgen` `5.0.1` from D-Bus introspection data.
//! Source: `io.github.wivrn.Server.xml`.
//!
//! You may prefer to adapt it, instead of using it verbatim.
//!
//! More information can be found in the [Writing a client proxy] section of the zbus
//! documentation.
//!
//! This type implements the [D-Bus standard interfaces], (`org.freedesktop.DBus.*`) for which the
//! following zbus API can be used:
//!
//! * [`zbus::fdo::PropertiesProxy`]
//!
//! Consequently `zbus-xmlgen` did not generate code for the above interfaces.
//!
//! [Writing a client proxy]: https://dbus2.github.io/zbus/client.html
//! [D-Bus standard interfaces]: https://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces,
use zbus::proxy;
#[proxy(
    interface = "io.github.wivrn.Server",
    default_path = "/io/github/wivrn/Server",
    default_service = "io.github.wivrn.Server"
)]
pub trait Server {
    /// DisablePairing method
    fn disable_pairing(&self) -> zbus::Result<()>;

    /// Disconnect method
    fn disconnect(&self) -> zbus::Result<()>;

    /// EnablePairing method
    fn enable_pairing(&self, TimeoutSecs: i32) -> zbus::Result<String>;

    /// Quit method
    fn quit(&self) -> zbus::Result<()>;

    /// RenameKey method
    fn rename_key(&self, PublicKey: &str, Name: &str) -> zbus::Result<()>;

    /// RevokeKey method
    fn revoke_key(&self, PublicKey: &str) -> zbus::Result<()>;

    /// AvailableRefreshRates property
    #[zbus(property)]
    fn available_refresh_rates(&self) -> zbus::Result<Vec<f64>>;

    /// EncryptionEnabled property
    #[zbus(property)]
    fn encryption_enabled(&self) -> zbus::Result<bool>;

    /// EyeGaze property
    #[zbus(property)]
    fn eye_gaze(&self) -> zbus::Result<bool>;

    /// FaceTracking property
    #[zbus(property)]
    fn face_tracking(&self) -> zbus::Result<bool>;

    /// FieldOfView property
    #[zbus(property)]
    fn field_of_view(&self) -> zbus::Result<Vec<(f64, f64, f64, f64)>>;

    /// HandTracking property
    #[zbus(property)]
    fn hand_tracking(&self) -> zbus::Result<bool>;

    /// HeadsetConnected property
    #[zbus(property)]
    fn headset_connected(&self) -> zbus::Result<bool>;

    /// JsonConfiguration property
    #[zbus(property)]
    fn json_configuration(&self) -> zbus::Result<String>;
    #[zbus(property)]
    fn set_json_configuration(&self, value: &str) -> zbus::Result<()>;

    /// KnownKeys property
    #[zbus(property)]
    fn known_keys(&self) -> zbus::Result<Vec<(String, String)>>;

    /// MicChannels property
    #[zbus(property)]
    fn mic_channels(&self) -> zbus::Result<u32>;

    /// MicSampleRate property
    #[zbus(property)]
    fn mic_sample_rate(&self) -> zbus::Result<u32>;

    /// PairingEnabled property
    #[zbus(property)]
    fn pairing_enabled(&self) -> zbus::Result<bool>;

    /// Pin property
    #[zbus(property)]
    fn pin(&self) -> zbus::Result<String>;

    /// PreferredRefreshRate property
    #[zbus(property)]
    fn preferred_refresh_rate(&self) -> zbus::Result<f64>;

    /// RecommendedEyeSize property
    #[zbus(property)]
    fn recommended_eye_size(&self) -> zbus::Result<(u32, u32)>;

    /// SpeakerChannels property
    #[zbus(property)]
    fn speaker_channels(&self) -> zbus::Result<u32>;

    /// SpeakerSampleRate property
    #[zbus(property)]
    fn speaker_sample_rate(&self) -> zbus::Result<u32>;

    /// SteamCommand property
    #[zbus(property)]
    fn steam_command(&self) -> zbus::Result<String>;

    /// SupportedCodecs property
    #[zbus(property)]
    fn supported_codecs(&self) -> zbus::Result<Vec<String>>;
}
